if (browser.isIE && browser.versionMajor < 9) {
  new XWiki.widgets.ModalPopup("It appears you are using Internet Explorer version 8 or below. Please install a newer version or a different browser to continue using PhenoTips.", {}, {"title": "Incompatible Browser"}).showDialog();
}
//close all suggest pickers when clicking outside the picker and dialogues invoked by the picker
document.observe('mousedown', function(event) {
  if (!event.findElement('.suggestItems') && !event.findElement('.dialog-ontology-browser')) {
    $$('.suggestItems').each(function(item) {
      if (item.__targetField && (item.__targetField._suggest || item.__targetField._suggestWidget || item.__targetField.__x_suggest)) {
        (item.__targetField._suggest || item.__targetField._suggestWidget || item.__targetField.__x_suggest).clearSuggestions();
       }
    });
  }
});

//if we use userPicker.js, since it is using native xwiki suggest.js, we attach suggest input to suggestion items dropdown object here
document.observe('xwiki:suggest:containerCreated', function(event) {
  if (event.memo && event.memo.container && event.memo.suggest && event.memo.suggest.fld) {
    event.memo.container.__targetField = event.memo.suggest.fld;
  }
});
document.observe('xwiki:dom:loaded', function() {
  // Edit buttons for every heading in view mode
  var editButton = $('prActionEdit');
  if (editButton) {
    $$('.chapter > h2[id]').each(function(title) {
      var editLink = new Element('a', {'class' : 'action-edit fa fa-pencil', 'href' : editButton.href + '#' + title.id, 'title' : 'Edit'});
      title.insert(editLink);
    });
  }
  if (!$('inline')) {return;}

  // , .chapter.phenotype-info .negative_phenotype-group
  $$('.chapter.phenotype-info .phenotype-group').invoke('addClassName', 'collapsible-group');

  $$('.chapter > h2').each(function(item){
    var showIcon = '<span class="fa fa-plus-square-o fa-lg"></span>&nbsp;';
    var chapterShow = new Element('button', {'class' : 'tool button secondary', 'type' : 'button'}).update(showIcon+"Show");
    var hideIcon = '<span class="fa fa-minus-square-o fa-lg"></span>&nbsp;';
    var chapterHide = new Element('button', {'class' : 'tool button secondary', 'type' : 'button'}).update(hideIcon+"Hide");
    var chapterShowWrapper = new Element('span', {'class' : 'buttonwrapper show'}).insert(chapterShow);
    var chapterHideWrapper = new Element('span', {'class' : 'buttonwrapper hide'}).insert(chapterHide);
    var chapterExpandTools = new Element('span', {'class' : 'expand-tools'}).insert(chapterShowWrapper).insert(chapterHideWrapper);
    item.insert({after: chapterExpandTools});
    [chapterShow, chapterHide, item].invoke('observe', 'click', function (event) {
      event.element().up('.chapter').toggleClassName('collapsed');
    });
  });
  $$('.chapter').each(function(item) {
     if (window.location.hash && item.down(window.location.hash)) {
       item.removeClassName('collapsed');
     }
  });
});
var PhenoTips = (function(PhenoTips) {
  // Start PhenoTips augmentation
  var widgets = PhenoTips.widgets = PhenoTips.widgets || {};

  /**
   * PhenoTips.widgets.FormUtils allows to:
   *  - check if the form displayed on the current page has unsaved changes
   *  - save that form and do something after saving
   * It also performs periodical autosave every 10s (only if there are unsaved modifications).
   *
   * HOW TO USE:
   *
   *  PhenoTips.widgets.FormUtils.getFormState() - returns an object representing the state of the current form
   *  Notes:
   *   - it always looks for the form with the id 'inline' (which is the convention for all forms for PhenoTips entities)
   *   - if there is no $('inline') form on the page, getFormState will still return an object
   *
   *  PhenoTips.widgets.FormUtils.getFormState().isFormDirty() - checks if there any unsaved changes
   *  Note: if there's no form on the page, it will automatically return false; otherwise it will check the actual form for unsaved changes

   *
   *  PhenoTips.widgets.FormUtils.getFormState().saveForm(successCallback, failureCallback) - saves the form and calls one of the callback
   *  functions depending on the result of the save attempt.
   *  Notes:
   *   - both callbacks are optional
   *   - if there's no failureCallback, when saving fails the user is prompted if successCallback (if provided) should be pursued anyway
   *   - if there's no form on the page, none of the callbacks is called
   *
   *  PhenoTips.widgets.FormUtils.getFormState().saveIfFormDirty(successCallback, failureCallback) - if there's a form with unsaved changes
   *  on the page, it behaves like saveForm(successCallback, failureCallback), otherwise it calls successCallback (if provided).
   *  Note: it is usually preferred to use saveIfFormDirty instead of saveForm, because:
   *   - it avoids unnecessary versions
   *   - it it guarantees the successCallback is executed if there aren't any pending modifications.
   *
   */
  widgets.FormUtils = Class.create({
    config : {
      // TODO: CONFIGURE IN THE ADMINISTRATION
      autosave : {
        enabled: true,
        frequency : 60 /*seconds */,
        message: 'Automatic save'
      }
    },
    initialize : function() {
      this.form = $('inline');
      if (this.form) {
        this.isFormDirty = this.isFormDirty.bind(this);
        this.form._formState = this;
        var _this = this;
        var recordFormData = function() {
          _this.formData = _this.form.serialize();
        };
        var bottomButtons = $$("input[name^='action_']");
        var updateSaveState = function(saving, recordData) {
          // Record the form's current save state.
          _this.form._saving = saving;
          // Buttons should be disabled when the form is saving, and enabled when not.
          bottomButtons.invoke('toggleClassName', 'disabled', saving);
          recordData && recordFormData();
        };
        // Some form elements are still being modified while "xwiki:dom:loaded" is fired.
        // If the initial state of the form is recorded immediately, there will likely be
        // differences with the state of the form when navigating away even if the user
        // hasn't actually changed any data.
        // Setting a timeout, even zero, delays the initialization until other
        // form elements have been modified already.
        setTimeout(recordFormData, 0);
        document.observe('xwiki:actions:save', updateSaveState.bind(this, true, false));
        // Record the state of the form again once the form is saved.
        document.observe('xwiki:document:saved', updateSaveState.bind(this, false, true));
        // Make sure to unlock form saving if save failed.
        document.observe("xwiki:document:saveFailed", updateSaveState.bind(this, false, false));
        // FIXME: The validation script simply stops the form submission, so there is no other way to find out that validation failed; refactor the way validation works
        document.observe("phenotips:scrollValidation:invalid", updateSaveState.bind(this, false, false));
        bottomButtons.invoke('observe', 'click', recordFormData);
        // Upon navigating away, check if anything has changed in the form and warn the user
        // if it did.
        window.addEventListener('beforeunload', function(event) {
          if (_this.isFormDirty()) {
            var message = "Are you sure you wish to leave this page? The data you entered in the form may be lost.";
            (event || window.event).returnValue = message;
            return message;
          }
          return undefined;
        });

        // Set up the smart autosave
        if (this.config.autosave.enabled) {
          this.timer = new PeriodicalExecuter(this.saveIfFormDirty.bind(this), this.config.autosave.frequency);
        }
      }
    },
    isFormDirty : function() {
      return this.form ? (this.formData != this.form.serialize()) : false;
    },
    saveForm : function(successCallback, failureCallback) {
      var onSaved = function () {
        document.stopObserving("xwiki:document:saved", onSaved);
        document.stopObserving("xwiki:document:saveFailed", onSaveFailed);
        if (typeof successCallback == 'function') {
          successCallback();
        }
      };
      var onSaveFailed = function () {
        document.stopObserving("xwiki:document:saved", onSaved);
        document.stopObserving("xwiki:document:saveFailed", onSaveFailed);
        if (typeof failureCallback == 'function') {
          failureCallback();
        } else if (typeof successCallback == 'function') {
          // If there's NO callback for when the saving failed, ask user if it's OK to proceed anyway with the successCallback
          (new XWiki.widgets.ConfirmationBox({
            onYes: successCallback,
            onNo: function(){}
          },
          {
            confirmationText: "Failed to save the latest modifications. Proceed anyway?", // "Failed to save the latest modifications. Proceed anyway?"
            showCancelButton: false
          })).showDialog();
        }
      };
      // If already saving data, don't initialize another save.
      if (this.form._saving) { return; }
      document.fire("xwiki:actions:save", {"continue": true, "form" : this.form});
      document.observe("xwiki:document:saved", onSaved);
      document.observe("xwiki:document:saveFailed", onSaveFailed);
    },
    saveIfFormDirty : function(successCallback, failureCallback) {
      if (this.isFormDirty()) {
        this.saveForm(successCallback, failureCallback);
      } else {
        // If there are no unsaved changes, just go straight to calling the successCallback function if one is provided.
        (typeof successCallback == 'function') && successCallback();
      }
    }
  });

  // Static function to get the form state
  widgets.FormUtils.getFormState = function() {
    return formState ;
  };
  var formState;
  var init = function(event) {
    formState = new PhenoTips.widgets.FormUtils();
  };

  (XWiki.domIsLoaded && init()) || document.observe("xwiki:dom:loaded", init);

  // End PhenoTips augmentation.
  return PhenoTips;
}(PhenoTips || {}));
var disableTitleTab = function(tab) {
  tab.removeClassName('active');
  tab.update(new Element('a', {'href' : XWiki.currentDocument.getURL($$('input[name="returnTo"]')[0].value)}).insert(XWiki.currentDocument.page));
};

var hideElement = function(id) {
  var elem = $(id);
  elem && elem.hide();
};

var cleanupUI = function(tab) {
  ['document-authors', 'patient-record-actions'].each(hideElement);
};

var enableCurrentTab = function(tab, cleanUI) {
  var tabHeading = tab.down('h1');
  var tabLink = tab.down('a');
  tab.addClassName('active');
  tabLink && tabLink.addClassName('hidden');
  tabHeading && tabHeading.removeClassName('hidden');
  cleanUI && cleanupUI(tab);
};

document.observe('xwiki:dom:loaded', function() {
  var currentTabIdEl = $('current-tab-id');
  var currentTabId = currentTabIdEl && currentTabIdEl.value;
  if (currentTabId) {
    var currentTab = $(currentTabId);

    // Disable the title tab.
    var documentTitle = $('document-title');
    // It should always be there, but check.
    documentTitle && disableTitleTab(documentTitle);
    enableCurrentTab(currentTab, currentTab.identify() !== 'document-title');
  }
});
